=== debian/changelog ===
weechat (4.5.1-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 24 Mar 2025 08:35:36 -0700

weechat (4.5.1-1) unstable; urgency=medium

  * New upstream release
  * Update copyright file (new year)

 -- Emmanuel Bouthenot <kolter@debian.org>  Mon, 20 Jan 2025 14:39:42 +0000
